[LeetCode] 1277. Count Square Submatrices with All Ones

Given a m * n matrix of ones and zeros, return how many square submatrices have all ones.

Example 1:
Input: matrix =
[
[0,1,1,1],
[1,1,1,1],
[0,1,1,1]
]
Output: 15
Explanation:
There are 10 squares of side 1.
There are 4 squares of side 2.
There is 1 square of side 3.
Total number of squares = 10 + 4 + 1 = 15.

Example 2:
Input: matrix =
[
[1,0,1],
[1,1,0],
[1,1,0]
]
Output: 7
Explanation:
There are 6 squares of side 1.
There is 1 square of side 2.
Total number of squares = 6 + 1 = 7.

Constraints:
1 <= arr.length <= 300
1 <= arr[0].length <= 300
0 <= arr[i][j] <= 1

统计全为1的正方形子矩阵。

给你一个 m * n 的矩阵,矩阵中的元素不是 0 就是 1,请你统计并返回其中完全由 1 组成的 正方形 子矩阵的个数。

思路

题意跟221题非常类似,给你一个只有 0 和 1 的二维矩阵,请你统计其中完全由 1 组成的正方形子矩阵的个数。思路是动态规划。动态规划的定义是 dp[i][j] 代表的是由 (i, j) 为右下角组成的矩形的个数。这个定义跟 221 题几乎一样,221 题的定义是以 (i, j) 为右下角组成的最大矩形的边长。为什么这个右下角的坐标也能定义能组成的矩形的个数呢,因为比如给你一个 2x2 的矩阵,如果矩阵内的 4 个位置都是 1 的话,右下角的坐标也是 1,这样由这个右下角的 1 能组成的矩形有两个,一个是 1x1 的,一个是 2x2 的。这一题的状态转移方程也是在看当前坐标的左边,右边和左上角的 dp 值,以决定当前坐标的 dp 值。

复杂度

时间O(mn)
空间O(1) - 因为是原地修改了矩阵的值

代码

Java实现

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
class Solution {
public int countSquares(int[][] matrix) {
// corner case
if (matrix == null || matrix.length == 0) {
return 0;
}

// normal case
int m = matrix.length;
int n = matrix[0].length;
int res = 0;
for (int i = 0; i < m; i++) {
for (int j = 0; j < n; j++) {
if (i > 0 && j > 0 && matrix[i][j] > 0) {
matrix[i][j] = min(
matrix[i - 1][j],
matrix[i][j - 1],
matrix[i - 1][j - 1]
) + 1;
}
res += matrix[i][j];
}
}
return res;
}

private int min(int a, int b, int c) {
return Math.min(a, Math.min(b, c));
}
}

相关题目

1
2
3
4
5
84. Largest Rectangle in Histogram
85. Maximal Rectangle
221. Maximal Square
1277. Count Square Submatrices with All Ones
1727. Largest Submatrix With Rearrangements

[LeetCode] 1277. Count Square Submatrices with All Ones
https://shurui91.github.io/posts/1405682268.html
Author
Aaron Liu
Posted on
May 22, 2020
Licensed under